=== wrapping/java/CMakeLists.txt ===
# 
add_subdirectory(openjp2)
